﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel.Design;
using System.Web.UI.Design;
using System.Web.UI.HtmlControls;

namespace eRecord
{
	[ParseChildren(true),PersistChildren(false)]
	[DefaultProperty("ItemList")]
	[ToolboxData("<{0}:eRecordAddControl runat=server></{0}:eRecordAddControl>")]
	public class eRecordAddControl : WebControl
	{
		private eRecordItems _items;
		[PersistenceMode(PersistenceMode.InnerProperty),
	   DesignerSerializationVisibility(
		   DesignerSerializationVisibility.Content), Category("Behavior")]
		public eRecordItems ItemList
		{
			get
			{
				if (_items == null)
				{
					_items = new eRecordItems();
				}
				return _items;
			}
		}

		private bool RegisterCss(eRecordAddControl control)
		{
			if (!DesignMode)
			{
				string cssFile = Page.ClientScript.GetWebResourceUrl(typeof(eRecordAddControl), "eRecord.JCalendar.css");
				return control.RegisterCSSFile(control.Page.Header, cssFile);
			}
			return false;
		}

		bool RegisterCSSFile(HtmlHead head, string cssFile)
		{
			bool added = false;
			foreach (Control c in head.Controls)
			{
				HtmlLink link = c as HtmlLink;
				if (link != null)
				{
					if (link.Href == cssFile)
					{
						added = true;
						break;
					}
				}
			}
			if (!added)
			{
				HtmlLink link = new HtmlLink();
				link.Href = cssFile;
				link.Attributes["type"] = "text/css";
				link.Attributes["rel"] = "Stylesheet";
				link.Attributes["rev"] = "Stylesheet";
				head.Controls.Add(link);
				added = true;
			}
			return added;
		}

		private void RegisterJavascript()
		{
			Page.ClientScript.RegisterClientScriptResource(typeof(eRecordAddControl), "eRecord.JCalendar.js");
			Page.ClientScript.RegisterClientScriptResource(typeof(eRecordAddControl), "eRecord.Basic.js");
		}

		public void doPost()
		{

		}

		protected override void OnPreRender(EventArgs e)
		{
			RegisterCss(this);
			RegisterJavascript();
		}

		private string buildControl(eRecordItemStyle style)
		{
			string __HTML = string.Empty;
			switch (style)
			{
				case eRecordItemStyle.Text:

					break;
				case eRecordItemStyle.Number:

					break;
				case eRecordItemStyle.Boolean:

					break;
				case eRecordItemStyle.Checked:

					break;
				case eRecordItemStyle.DateTime:

					break;
				case eRecordItemStyle.List:

					break;
				default:
					break;
			}
		}

		protected override void RenderContents(HtmlTextWriter output)
		{
			//foreach (eRecordItem __item in ItemList)
			//{
			//    eRecordItem dr = __item as eRecordItem;
			//    output.Write(__item.Label);
			//}
			//output.Write("<script type=\"text/javascript\">\n"+
			//                "window.onload = function(){\n" +
			//                "var j = new JCalendar();\n" +
			//                "j.setYears(1990,2020);\n" +
			//                "j.bind('a',\"bottom\");\n" +
			//            "}\n</script>\n");
			output.Write("<input name=\"a\" type=\"text\" id=\"a\" />");
		}
	}
}
